/*
 * CLCL
 *
 * Data.h
 *
 * Copyright (C) 1996-2019 by Ohno Tomoaki. All rights reserved.
 *		https://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_DATA_H
#define _INC_DATA_H

/* Include Files */

/* Define */
// data type
#define TYPE_DATA						0
#define TYPE_ITEM						1
#define TYPE_FOLDER						2
#define TYPE_ROOT						3

/* Struct */
// ACe
typedef struct _DATA_INFO {
	DWORD struct_size;					// \̂̃TCY

	int type;							// TYPE_
	TCHAR *title;						// ^Cg

	TCHAR *format_name;					// `
	int format_name_hash;				// `̃nbV
	UINT format;						// `l

	HANDLE data;						// f[^
	DWORD size;							// TCY

	FILETIME modified;					// XV
	TCHAR *window_name;					// Rs[EBhE^Cg

	TCHAR *plugin_string;				// vOCpf[^
	LPARAM plugin_param;

// ȉۑȂ
	TCHAR *menu_title;					// j[ɕ\^Cg (ݒ̏ꍇ͌`\)
	BOOL free_title;					// ^Cg TRUE- FALSE-Ȃ
	HICON menu_icon;					// j[ɕ\ACRnh
	BOOL free_icon;						// ACRnh TRUE- FALSE-Ȃ
	HBITMAP menu_bitmap;				// j[ɕ\rbg}bv
	BOOL free_bitmap;					// rbg}bvnh TRUE- FALSE-Ȃ
	int menu_bmp_width;					// j[ɕ\rbg}bv̌ʃTCY
	int menu_bmp_height;
	LPARAM param1;						// vOCpf[^
	LPARAM param2;

	struct _DATA_INFO *child;
	struct _DATA_INFO *next;

// Ver 1.0.5
	int hkey_id;						// zbgL[
	UINT op_modifiers;
	UINT op_virtkey;
	int op_paste;
} DATA_INFO;

/* Function Prototypes */
DATA_INFO *data_create_data(const UINT format, TCHAR *format_name, const HANDLE data, const DWORD size, const BOOL init, TCHAR *err_str);
DATA_INFO *data_create_item(const TCHAR *title, const BOOL set_date, TCHAR *err_str);
DATA_INFO *data_create_folder(const TCHAR *title, TCHAR *err_str);
DATA_INFO *data_item_copy(const DATA_INFO *di, const BOOL next_copy, const BOOL move_flag, TCHAR *err_str);
BOOL data_delete(DATA_INFO **root, DATA_INFO *del_di, const BOOL free_item);
void data_adjust(DATA_INFO **root);
void data_menu_free_item(DATA_INFO *di);
void data_menu_free(DATA_INFO *di);
void data_free(DATA_INFO *di);
DATA_INFO *data_check(DATA_INFO *di, const DATA_INFO *check_di);
void data_set_modified(DATA_INFO *di);
BOOL data_get_modified_string(const DATA_INFO *di, TCHAR *ret);
TCHAR *data_get_title(DATA_INFO *di);

#endif
/* End of source */
